<?php
/*
Plugin Name: HREF Filter
Plugin URI: http://www.codehooligans.com/projects/wordpress
Description: This plugin allows the user to setup filters to search/replace the HREF value for the anchors on a given rendered page. This process uses JavaScript and kicks off after the page loads. This plugin does not filter page code via WordPress.
Version: 1.0
Author: Paul Menard
Author URI: http://www.codehooligans.com
*/

// Globals ------------
$ch_hf_table_name = $table_prefix . "ch_href_filter";
$ch_hf_row_global = array();
$this_file = basename(__FILE__);

// Required user level to access admin panel
$ch_hf_admin_level = 8;


function ch_hf_loader($no_onload = 0) 
{
	$ch_hf_rows = ch_hf_load_list("active");
	if (count($ch_hf_rows) > 0)
	{
		if ($no_onload == 0)
		{
			?>
			<script language="JavaScript"><!--
			function addLoadEvent(func) 
			{
				var oldonload = window.onload;
				if (typeof window.onload != 'function') 
				{
					window.onload = func;
				} 
				else 
				{
					window.onload = function() 
					{
						oldonload();
						func();
					}
				}
			}		
			addLoadEvent(ch_hf_proc_links);
			<?php
		}
		?>
		
		// This function is actually used for the filter item array. 
		function ch_hf_filter(filter_type, search_str, replace_str) 
		{
			this.filter_type	= filter_type;
			this.search_str		= search_str;
			this.replace_str	= replace_str;
		}

		function ch_hf_proc_links()
		{
			f_array = new Array()
			<?php
				foreach ($ch_hf_rows as $ch_hf_row_current)
				{
					if ($ch_hf_row_current->ch_hf_replace_str[0] == "/")
						$ch_hf_row_current->ch_hf_replace_str = get_bloginfo('url') . $ch_hf_row_current->ch_hf_replace_str;
					?>
					f_array[f_array.length] = new ch_hf_filter(<?php echo $ch_hf_row_current->ch_hf_pattern_replace ?>, 
						"<?php echo $ch_hf_row_current->ch_hf_pattern_str; ?>", 
						"<?php echo $ch_hf_row_current->ch_hf_replace_str; ?>");
					<?php
				}
			?>
			var a_links = document.getElementsByTagName("A");
			process_links(a_links, f_array);
		}
		
		function process_links(links, filters)
		{
			for (var filter_idx = 0; filter_idx < filters.length; filter_idx++)
			{
				for (var links_idx = 0; links_idx < links.length; links_idx++) 
				{
					if (links[links_idx].href.length > 0)
					{
						if (links[links_idx].href.indexOf(filters[filter_idx].search_str) > -1)
						{
							if (filters[filter_idx].filter_type == 0)
							{
								links[links_idx].href = filters[filter_idx].replace_str;
							}
							else
							{
								var input_str = links[links_idx].href;
								var regex_str = new RegExp(filters[filter_idx].search_str, "gi");
								var output_str=input_str.replace(regex_str, filters[filter_idx].replace_str);
								links[links_idx].href = output_str;
							}
						}
					}
				}
			}
		}
		//--></script>
		<?php
	}
}


function ch_hf_admin_head() 
{ 
	?><script type="text/javascript" src="<?php echo get_bloginfo('wpurl') . "/wp-content/plugins/href_filter/admin.js"; ?>"></script><?php 
}

function ch_hf_options_page() 
{
	global $wp_roles;
	
	echo "roles<pre>"; print_r($wp_roles); echo "</pre>";
	
/*
$role_select = '<select name="new_role">';
	foreach($wp_roles->role_names as $role => $name) 
	{
		$role_select .= "<option value=\"{$role}\">{$name}</option>";
	}
	$role_select .= '</select>';
*/
	?>
	<div class="wrap">
		<h2>HREF Filter Options</h2>
		<p>The main HREF Filter interface is located under the 'Manage' menu option. This Options panel allow the Admin-level users to 
			restrict access to the Manage panel</p>
		<p>The lowest level WordPress user access that can access the Home -> Manage -> HREF Filter page</p>
		
		


	</div>
	<?php 
}

// mt_manage_page() displays the page content for the Test Manage submenu
function ch_hf_manage_page() 
{
	global $_REQUEST;

	if ($_REQUEST['ch_hf_action'] == "Save HREF Filter")
	{
		if (ch_hf_update_filter())
		{
			?>
			<div class="updated">
				<p>HREF Filter #<?php echo $_REQUEST['ch_hf_id']; ?> successfully updated.</p>
			</div>
			<?php
		}
	}
	if ($_REQUEST['ch_hf_action'] == "Save New HREF Filter")
	{
		if (ch_hf_update_filter())
		{
			?>
			<div class="updated">
				<p>HREF Filter successfully added.</p>
			</div>
			<?php
		}
	}
	else if ($_REQUEST['ch_hf_action'] == "Delete")
	{
		if (ch_hf_delete_filter())
		{
			?>
			<div class="updated">
				<p>HREF Filter #<?php echo $_REQUEST['ch_hf_id']; ?> successfully deleted.</p>
			</div>
			<?php
		}
	}		
	?>
	<div class="wrap">
		<?php 

			ch_hf_show_list(); 

			// When a user edits an HREF Filter
			if (($_REQUEST['ch_hf_action'] == "Edit")
			 ||	($_REQUEST['ch_hf_action'] == "Create New Filter"))
			{
				ch_hf_show_form(); 
			}
		?>
	</div>
	<?php
}

function ch_hf_update_filter()
{
	global $ch_hf_table_name, $wpdb,  $_REQUEST;

	if (!isset($_REQUEST['ch_hf_uid']))
	{
		global $userdata;
	
		get_currentuserinfo();
		$_REQUEST['ch_hf_uid'] = $userdata->ID;		
	}
	

	if ($_REQUEST['ch_hf_action'] == "Save New HREF Filter")
	{
		$query_str = 	"INSERT INTO {$ch_hf_table_name} VALUES ('', " . 	$_REQUEST['ch_hf_active'] . ", ".
																			$_REQUEST['ch_hf_uid'] . ", " . 
																			$_REQUEST['ch_hf_pattern_replace'] . ", '" .
																			$wpdb->escape($_REQUEST['ch_hf_pattern_str']) . "', '" .
																			$wpdb->escape($_REQUEST['ch_hf_replace_str']) . "');";
	}
	else
	{
		$query_str = 	"UPDATE {$ch_hf_table_name} SET 
						ch_hf_active=" . $_REQUEST['ch_hf_active'] . ",
						ch_hf_uid=" . $_REQUEST['ch_hf_uid'] . ",
						ch_hf_pattern_replace=" . $_REQUEST['ch_hf_pattern_replace'] . ",
						ch_hf_pattern_str='" . $wpdb->escape($_REQUEST['ch_hf_pattern_str']) . "',
						ch_hf_replace_str='" . $wpdb->escape($_REQUEST['ch_hf_replace_str']) . "'
						WHERE ch_hf_id=" . $_REQUEST['ch_hf_id'];
	}
	$wpdb->get_results($query_str);
	if ($wpdb->result == 1) // SUCCESS
		return 1;
	else
		return 0;
}

function ch_hf_delete_filter()
{
	global $ch_hf_table_name, $wpdb,  $_REQUEST;
	
	$query_str = 	"DELETE FROM {$ch_hf_table_name} WHERE ch_hf_id=" . $_REQUEST['ch_hf_id'];
	$wpdb->get_results($query_str);

	if ($wpdb->result == 1) // SUCCESS
		return 1;
	else
		return 0;
}

function ch_hf_load_list($filter="all")
{
	global $ch_hf_table_name, $wpdb;

	if ($filter == "active")
		$x = $wpdb->get_results("SELECT * from {$ch_hf_table_name} WHERE ch_hf_active=1 ORDER BY ch_hf_id");
	else if ($filter == "all")
		$x = $wpdb->get_results("SELECT * from {$ch_hf_table_name} ORDER BY ch_hf_id");
	return $x;
}

function ch_hf_load_user_list()
{
	global $ch_hf_table_name, $wpdb;
	global $userdata;

	get_currentuserinfo();
	//echo "userdata<pre>"; print_r($userdata); echo "</pre>";
	//echo "ID=[" . $userdata->ID . "]<br>";

	$sql_query = 	"SELECT wpu.ID, wpu.display_name, wpum.meta_value FROM wp_users as wpu ".
					"INNER JOIN wp_usermeta as wpum ".
					"ON  wpu.ID=wpum.user_id ".
					"WHERE wpum.meta_key='wp_user_level' ".
					"AND (wpu.ID = " . $userdata->ID . " OR wpum.meta_value < " . $userdata->wp_user_level . ")";
	//echo "sql_query=[" . $sql_query . "]<br>";

	$x = $wpdb->get_results($sql_query);

/*

	foreach($x as $user)
	{
		$user['first_name'] 	= get_author_meta($user->ID, "first_name");
		$user['last_name'] 		= get_author_meta($user->ID, "last_name");
		echo "USER_INFO<pre>"; print_r($user); echo "</pre>";
		
	}
*/
	
	return $x;
}

function ch_hf_show_list()
{
	global $this_file, $ch_hf_row_global, $_REQUEST;
	
	?><h2>Manage HREF Filters</h2><?php

	$ch_hf_users_global = ch_hf_load_user_list();

	$ch_hf_rows = ch_hf_load_list();
	if ($ch_hf_rows)
	{
		?>
		<table width="100%" border="0" cellspacing="3" cellpadding="3">
		<tr>
			<th scope="col">ID</th>
			<th scope="col">Active</th>
			<th scope="col">User</th>
			<th scope="col">Search for...</th>
			<th scope="col">Replace Method</th>
			<th scope="col">Replace with...</th>
		</tr>
		<?php
		foreach ($ch_hf_rows as $ch_hf_row_current)
		{
			$user_name="";
			foreach ($ch_hf_users_global as $users)
			{
				if ($users->ID == $ch_hf_row_current->ch_hf_uid)
				{
					$user_name = $users->display_name;
					break;
				}
			}

			if ($_REQUEST['ch_hf_action'] == "Edit")
			{
				if ($ch_hf_row_current->ch_hf_id == $_REQUEST['ch_hf_id'])
				{
					$ch_hf_row_global = $ch_hf_row_current;
				}
			}
			?>
			<tr>
			   <td style="text-align: center"><?php echo $ch_hf_row_current->ch_hf_id; ?></td>
			   <td style="text-align: center"><?php if ($ch_hf_row_current->ch_hf_active == 1){echo "Yes";} else{ echo "No";} ?></td>
			   <td style="text-align: left"><?php echo $user_name; //$ch_hf_row_current->ch_hf_uid; ?></td>
			   <td style="text-align: left"><?php echo $ch_hf_row_current->ch_hf_pattern_str; ?></td>
			   <td style="text-align: left">
					<?php
						if ($ch_hf_row_current->ch_hf_pattern_replace == 1)
						{ 
							echo "Replace only matched string";
						} 
						else
						{ 
							echo "Replace full HREF value";
						} 
					?>
				</td>
			   	<td style="text-align: left"><?php echo $ch_hf_row_current->ch_hf_replace_str; ?></td>
				<td style="text-align: center">
					<form action="" method="get">
					<div>
					   <input type="hidden" name="page" value="<?php echo $this_file ?>" />
					   <input type="hidden" name="ch_hf_id" value="<?php echo $ch_hf_row_current->ch_hf_id; ?>" />
					   <input type="submit" value="Edit" name="ch_hf_action">
					   <input type="submit" value="Delete" name="ch_hf_action"
							onclick="return confirm('You are about to delete this HREF Filter.\n  \'Cancel\' to stop, \'OK\' to delete.');" />
				   </div>
					</form>
				</td>
			</tr>
			<?php 
		} 
		?>
		</table>
		<?php
	} 
	else 
	{ 
		echo "<br />You have no HREF Filters in the database. Add a new one!<br /><br />"; 
	} 
	
	?>
	<table width="100%" border="0" cellspacing="3" cellpadding="3">
	<tr>
		<td style="text-align: left">
			<form edit.php?page=<?php echo $this_file ?>" method="post">
				<div>
				   <input type="submit" value="Create New Filter" name="ch_hf_action">
			   </div>
			</form>
		</td>
	</tr>
	</table>
	<br />
	<?php
}

function ch_hf_show_form()
{
	global $ch_hf_row_global, $this_file;
	
	$form_header_str 	= "";
	$form_button_str 	= "";
	$form_action		= "";
	
	if ( (isset($ch_hf_row_global->ch_hf_id)) && ($ch_hf_row_global->ch_hf_id > 0))
	{
		$form_header_str = "Edit HREF Filter";
		$form_button_str = "Save HREF Filter";
		$form_action = "edit_save";
	}
	else
	{
		$form_header_str = "Add new HREF Filter";
		$form_button_str = "Save New HREF Filter";
		$form_action = "add_new";

/*
		echo "here";
		global $userdata;
		get_currentuserinfo();

		echo "userdata<pre>"; print_r($userdata); echo "</pre>";
		
		$ch_hf_row_global->ch_hf_uid = $userdata->ID;
		echo "ID=[" . $userdata->ID . "]<br>";
		echo "uid=[" . $ch_hf_row_global->ch_hf_uid . "]<br>";
*/
	}

	// $ch_hf_users_global = ch_hf_load_user_list();
	?>
	<h2><?php echo $form_header_str ?></h2>
	<form action="edit.php?page=<?php echo $this_file ?>" method="post" onSubmit="return validate_filter_input(this);">
	<input type="hidden" name="ch_hf_id" value="<?php echo $ch_hf_row_global->ch_hf_id ?>">
	<div id="form_questions">	
		<label for="ch_hf_active">Filter Active</label><br />
			<select name="ch_hf_active" id="ch_hf_active">
				<option value="1" <?php if ($ch_hf_row_global->ch_hf_active == 1) echo "selected" ?> >Yes</option>
				<option value="0" <?php if ($ch_hf_row_global->ch_hf_active == 0) echo "selected" ?> >No</option>
			</select><br /><br />

<!--
		<label for="ch_hf_uid">Owner</label><br />
			<select name="ch_hf_uid" id="ch_hf_uid">
				<?php
				if (count($ch_hf_users_global))
				{
					foreach ($ch_hf_users_global as $users)
					{
						?><option value="<?php echo $users->ID ?>"
							<?php 
								if ($users->ID == $ch_hf_row_global->ch_hf_uid) 
								{
									echo "selected";
								}
							?>><?php echo $users->display_name ?></option><?php
					}
				}
				?>
			</select><br />You can assign this Filter to anyone with less authority than youself.<br /><br />
-->
		<label for="ch_hf_pattern_str">Search for...</label><br />
			<input type="text" size="50" maxlength="200" value="<?php echo $ch_hf_row_global->ch_hf_pattern_str ?>" 
				name="ch_hf_pattern_str" id="ch_hf_pattern_str" /><br />Enter a partial or full URL that may appear on your site. Examples are http://somesite.org/the, somesite.<br/ ><br />

		<label for="ch_hf_pattern_replace">Replace Method</label><br />
			<select name="ch_hf_pattern_replace" id="ch_hf_pattern_replace">
				<option value="1" <?php if ($ch_hf_row_global->ch_hf_pattern_replace == 1) echo "selected" ?> >Replace only matched string</option>
				<option value="0" <?php if ($ch_hf_row_global->ch_hf_pattern_replace == 1) echo "selected" ?> >Replace full HREF value</option>
			</select><br />
			Examples:<br />
				Replace only matched string - This works like a search and replace. Search for 'xxx' pattern and replace with 'yyyy'. Yes, the length can be different.<br /><br />
				Replace full HREF value - Find any HREF that contains the 'xxx' pattern and replace the entire HREF value with the pattern 'yyyy'. Note in this method the replacement 'yyyy' value needs to be a fully qualified HREF http://....<br />
			
			<br />
			
		<label for="ch_hf_replace_str">Replace with...</label><br />
			<input type="text" size="50" maxlength="200" value="<?php echo $ch_hf_row_global->ch_hf_replace_str ?>" 
				name="ch_hf_replace_str" id="ch_hf_replace_str" /><br /><br />
		<input type="submit" value="<?php echo $form_button_str ?>" name="ch_hf_action"/>
		<input type="button" value="Cancel" name="ch_hf_action" onClick="location.href='edit.php?page=<?php echo $this_file ?>'" />
	</div>
	</form>

	<?php
}

function ch_hf_install () 
{
	global $ch_hf_table_name, $wpdb;
	global $userdata;
	
	$result = mysql_list_tables(DB_NAME);
	$tables = array();

	while ($row = mysql_fetch_row($result)) { $tables[] = $row[0]; }
	$first_install = (in_array($ch_hf_table_name, $tables)) ? FALSE : TRUE;
    if ($first_install == true) 
    {
	   $qry = "CREATE TABLE {$ch_hf_table_name} (
            ch_hf_id int(10) unsigned NOT NULL auto_increment,
            ch_hf_active int(10) NOT NULL default 0,
            ch_hf_uid int(10) NOT NULL default 0,
			ch_hf_pattern_replace TINYINT default 0,
            ch_hf_pattern_str varchar(200) NOT NULL default '',
            ch_hf_replace_str varchar(200) NOT NULL default '',
            PRIMARY KEY  (ch_hf_id), INDEX ( ch_hf_uid )
           );";

	    require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
    	dbDelta($qry);

		get_currentuserinfo();

        // Add In Poll Question/Answers
        $sql[] = "INSERT INTO {$ch_hf_table_name} VALUES ('', 0, " . $userdata->ID . ", 1, 'somehost.com', 'otherhost.com');";        
        $sql[] = "INSERT INTO {$ch_hf_table_name} VALUES ('', 0, " . $userdata->ID . ", 0, 'somehost.com', 'http://otherhost.com/path1/page1.html');";

        foreach($sql as $query) 
        {
        	$wpdb->query($query);
        }
    }
}

function ch_hf_add_pages() 
{
    // Add a new menu under Manage:
    add_management_page('HREF Filter', 'HREF Filter', 8, 'href_filter', 'ch_hf_manage_page');

    // Add a new menu under Options:
    //add_options_page('HREF Filter', 'HREF Filter', 8, 'href_filter', 'ch_hf_options_page');
}

// Make sure WP is running
if (function_exists('add_action')) 
{
	// Insert the mt_add_pages() sink into the plugin hook list for 'admin_menu'
	add_action('admin_menu', 'ch_hf_add_pages');

    if ($_REQUEST['page'] == "href_filter.php")
		add_action('admin_head', 'ch_hf_admin_head');
	
	// Hook into the Plugin API
	add_action('wp_head', 'ch_hf_loader');
	
    // Run the install script if a plugin is activated
    if (isset($_REQUEST['activate']) && $_REQUEST['activate'] == 'true')
       add_action('init', 'ch_hf_install');

}
?>